package cn.com.tenlion.materialstore.service.materialstore;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materialstore.MaterialStoreDTO;
import cn.com.tenlion.materialstore.pojo.vos.materialstore.MaterialStoreVO;
import cn.com.tenlion.materialstore.pojo.bos.materialstore.MaterialStoreBO;
import cn.com.tenlion.materialstore.pojo.pos.materialstore.MaterialStorePO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialStoreService
 * @Description: CBC素材包
 * @Author: CodeFactory
 * @Date: 2021-08-24 11:13:38
 * @Version: 3.0
 **/
public interface IMaterialStoreService {

    /**
     * 新增CBC素材包
     *
     * @param materialStoreVO
     * @return
     */
    void save(MaterialStoreVO materialStoreVO);

    /**
     * 新增CBC素材包
     *
     * @param token
     * @param materialStoreVO
     * @return
     */
    void save(String token, MaterialStoreVO materialStoreVO);

    /**
     * 新增CBC素材包
     *
     * @param materialStoreVO
     * @return materialStoreId
     */
    String saveReturnId(MaterialStoreVO materialStoreVO);

    /**
     * 新增CBC素材包
     *
     * @param token
     * @param materialStoreVO
     * @return materialStoreId
     */
    String saveReturnId(String token, MaterialStoreVO materialStoreVO);

    /**
     * 删除CBC素材包
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除CBC素材包
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除CBC素材包（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改CBC素材包
     *
     * @param materialStoreId
     * @param materialStoreVO
     * @return
     */
    void update(String materialStoreId, MaterialStoreVO materialStoreVO);

    /**
     * 修改CBC素材包
     *
     * @param token
     * @param materialStoreId
     * @param materialStoreVO
     * @return
     */
    void update(String token, String materialStoreId, MaterialStoreVO materialStoreVO);

    /**
     * CBC素材包详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialStoreDTO get(Map<String, Object> params);

    /**
     * CBC素材包详情
     *
     * @param materialStoreId
     * @return
     */
    MaterialStoreDTO get(String materialStoreId);

    /**
     * CBC素材包详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialStoreBO getBO(Map<String, Object> params);

    /**
     * CBC素材包详情
     *
     * @param materialStoreId
     * @return
     */
    MaterialStoreBO getBO(String materialStoreId);

    /**
     * CBC素材包详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialStorePO getPO(Map<String, Object> params);

    /**
     * CBC素材包详情
     *
     * @param materialStoreId
     * @return
     */
    MaterialStorePO getPO(String materialStoreId);

    /**
     * CBC素材包列表
     *
     * @param params
     * @return
     */
    List<MaterialStoreDTO> list(Map<String, Object> params);

    /**
     * CBC素材包列表
     *
     * @param params
     * @return
     */
    List<MaterialStoreBO> listBO(Map<String, Object> params);

    /**
     * CBC素材包列表
     *
     * @param params
     * @return
     */
    List<MaterialStorePO> listPO(Map<String, Object> params);

    /**
     * CBC素材包分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialStoreDTO>> listPage(ListPage page);

    /**
     * CBC素材包统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}